<?PHP

	/*********************************
	 * Filemanager Script            *
	 *                               *
	 * Konstrukt - Plugin Verwalung  *
	 * by Firebird                   *
	 *********************************/

	 $pluginDir = $ScriptBaseDir.'/plugins/';
	 
	 // Funktion zum Aufruf von Plugins
	 function callPlugin($func)
	 {
	 	global $pluginList;
	 	if(func_num_args() > 1)
	 	{
	 		$myArgs = func_get_args();
	 		array_shift($myArgs);
	 	}
	 	
	 	$retVal = 0;
	 	
	 	if(isset($pluginList[$func]))
	 		foreach($pluginList[$func] as $funcName)
	 			$retVal ^= call_user_func_array($funcName, $myArgs);
	 			
	 	return $retVal;
	 }
 
	 // Plugins laden
	 $pluginList = array();
	 $pluginFiles = array();
	 $pluginAbsFiles = array();
	 
	 // Dateien auflisten
	 $oPluginDir = dir($pluginDir);
	 while(is_string($sPluginFile = $oPluginDir->read()))
	 {
	 	if($sPluginFile[0] == '.') continue;
	 	if(strtolower(substr($sPluginFile, -4)) != '.php') continue;
	 	
	 	$baseName = substr($sPluginFile, 0, -4);
	 	$pluginFiles[] = $baseName;
	 	$pluginAbsFiles[] = $pluginDir.$sPluginFile;
	 }
	 
	 sort($pluginAbsFiles);
	 
	 reset($pluginAbsFiles);
	 while($pluginAbsFile = current($pluginAbsFiles))
	 {
	 	require($pluginAbsFile); 	
	 	if(!next($pluginAbsFiles)) break;
	 }
	 	
	 // Funktionen laden
	 $tmpFuncs = get_defined_functions();
	 foreach($tmpFuncs['user'] as $parm)
	 	foreach($pluginFiles as $pluginFile)
	 		if(!strncmp($parm, $pluginFile, strlen($pluginFile)))
	 			$pluginList[substr($parm, strlen($pluginFile) + 1)][] = $parm;
?>