<?PHP

	/*********************************
	 * Filemanager Script            *
	 *                               *
	 * Plugin - Filesize             *
	 * by Firebird                   *
	 *                               *
	 * Update by LLCoolDanny         *
	 *                               *
	 *********************************/
	
	// Zustzliche Tabellen Spalten
	function file_size_additional_table_cols() {
		echo('<th>Dateigr&ouml;&szlig;e</th>');
	}
	
	// Zustzliche Tabellen Spalten bei Dateien
	function file_size_output_file($file) {
		echo('<td>'.file_size($file).'</td>');
	}
	
	// Zustzliche Tabellen Spalten bei Ordnern
	function file_size_output_dir($dir) {
		echo('<td>'.file_size(dirSize($dir), 'out').'</td>');
	}
	
	function file_size($File, $mode = 'read') {
		$File = $mode=='read' ? filesize($File) : $File;
		
		if($File<1024) {
			return ($File.' Bytes');
		}
		if($File>1024 AND $File<1048576) {
			return (round($File/1024, 2).' KB');
		}
		if($File>1048576 AND $File>1024) {
			return (round($File/1024/1024, 2).' MB');
		}
		if($File>1073741824 AND $File>1048576) {
			return (round($File/1024/1024/1024, 2).' GB');
		}
	}
	
	function dirSize($parseDir) {
		if(!$dir = @dir($parseDir)) return 0;
		$size = 0;
		
		while($obj = $dir->read()) {
			if($obj!='.' AND $obj!='..') {
				$full_path = './'.$parseDir.'/'.$obj;
				
				if(is_dir($full_path)) {
					$size += dirSize($full_path.'/');
				} else {
					$size += filesize($full_path);
				}
			}
		}
		$dir->close();
		return $size;
	}
?>